﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.48
@EndOfDesignText@
' clsMyNumKeysMap - Standard Class
' Author: LucaMs - AKA Mario
#Region + VERSIONS 
' V. 1.0	09/08/2018
#End Region

#Region + EVENTS' DECLARATIONS 
#End Region

Sub Class_Globals
	Private mCallback As Object
	Private mEventName As String
	
#Region + PROPERTIES' MEMBER VARIABLES 
	Private mMap As Map
	Private mDeletedKeys As List
#End Region
	
End Sub

Public Sub Initialize(Callback As Object, EventName As String)
	mCallback = Callback
	mEventName = EventName
	mMap.Initialize
	mDeletedKeys.Initialize
End Sub

#Region + PROPERTIES 

Public Sub GetMap As Map
	Return mMap
End Sub

Public Sub getSize As Int
	Return mMap.Size
End Sub

#End Region

#Region + METHODS 

#Region + PUBLIC METHODS 

Public Sub AddItem(Item As Object)
	Dim NextKey As Int
	If mDeletedKeys.Size > 0 Then
		mDeletedKeys.Sort(True)
		NextKey = mDeletedKeys.Get(0)
		mDeletedKeys.RemoveAt(0)
	Else
		NextKey = mMap.Size
	End If
	mMap.Put(NextKey, Item)
End Sub

Public Sub RemoveItem(Key As Int)
	mMap.Remove(Key)
	mDeletedKeys.Add(Key)
End Sub

Public Sub ContainsKey(Key As Int) As Boolean
	Return mMap.ContainsKey(Key)
End Sub

Public Sub GetItem(Key As Int) As Object
	Return mMap.Get(Key)
End Sub

Public Sub GetNextKey As Int
	Dim Result As Int = mMap.Size
	If mDeletedKeys.Size > 0 Then
		mDeletedKeys.Sort(True)
		Result = mDeletedKeys.Get(0)
	End If
	Return Result
End Sub

#End Region

#Region + PRIVATE METHODS 
#End Region

#End Region

#Region + EVENTS 
#End Region
